public class Erbteilung {
  
  public static int muenzen[] =
         {15, 27, 39, 7, 23, 56, 13, 39, 22, 5, 42, 34};
  public static int anzahlMuenzen = 12;
  
  // Verwaltung des aktuellen Suchpfades
  public static int genommeneMuenzen[] = new int[anzahlMuenzen];
  public static int anzahlGenommene = 0;
  public static int aktuelleSumme = 0;

  // globale Informationen
  public static int erbteilhaelfte = 0;
  public static boolean loesung = false;

  public static boolean annehmbar (int i) {
    return (aktuelleSumme + muenzen[i] <= erbteilhaelfte);
    } // Ende annehmbar
  
  public static void nehmen (int i) {
    aktuelleSumme = aktuelleSumme + muenzen[i];
    genommeneMuenzen[anzahlGenommene] = muenzen[i];
    anzahlGenommene++;
    } // Ende nehmen
  
  public static void zurueckgeben (int i) {
    anzahlGenommene--;
    genommeneMuenzen[anzahlGenommene] = 0;
    aktuelleSumme = aktuelleSumme - muenzen[i];
    } // Ende zurueckgeben

  public static void suchBaumAbsuchen (int k) {
    for (int i = k; i < anzahlMuenzen && !loesung; i++)
      if (annehmbar(i)) {
        nehmen(i);
        if (aktuelleSumme == erbteilhaelfte)
          loesungAusgeben();
        else
          suchBaumAbsuchen(i + 1);
        zurueckgeben(i);
        } // Ende else
    } // Ende suchBaumAbsuchen
  
  public static void loesungAusgeben() {
    System.out.print("\n Folgende Muenzen ergeben eine Loesung: ");
    for (int i = 0; i < anzahlGenommene; i++)
      System.out.print(" " + genommeneMuenzen[i]);
    System.out.println();
    loesung = true;
    } // loesungAusgeben

  public static void main (String[] xyz) {
    int summe = 0;
    for (int i = 0; i < anzahlMuenzen ; i++)
      summe = summe + muenzen[i];
    if (summe % 2 == 0) {
      erbteilhaelfte = summe/2;
      suchBaumAbsuchen(0);
      } // Ende if
    if (!loesung)
      System.out.println(" Das Erbe fllt dem Kloster zu!");
    } // Ende main

  } // Ende Erbteilung
